useMB = 1
if useMB
	include \masm32\MasmBasic\MasmBasic.inc
else
	include \masm32\include\masm32rt.inc
endif
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 300000	; 1000000 would be a typical value; 500 cycles means 1600000000/500=3.2 Mio loops per second
SleepMs	= 20
uselib fpu

.data
MyQword	dq	1234567890123456789
MyR4	REAL4 12345.678
MyR8	REAL8 12345.67890e33
MyR10	REAL10 -1.2345678901234567890e-111

.data?
Dest	db 100 dup(?)

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	print "1.6 Ghz: 200 cycles == 8 Mio loops per second", 13, 10, 10
;		invoke wsprintf, offset Dest, chr$("%u"), 12345
;		print offset Dest, 13, 10
;		invoke umdtoa, 12345, offset Dest
;		print eax, 13, 10, 10
	REPEAT 2
		if useMB
;			invoke Sleep, SleepMs
;			movq xmm0, R8
;			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;				void Str$("%u", f:xmm0)
;			counter_end
;			print str$(eax), 9, "cycles for unsigned Str$(xmm0)", 13, 10

;			invoke Sleep, SleepMs
;			movq xmm0, R8
;			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;				void Str$("%f", f:xmm0)
;			counter_end
;			print str$(eax), 9, "cycles for signed Str$(xmm0)", 13, 10

			invoke Sleep, SleepMs
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				void Str$(12345)
			counter_end
			print str$(eax), 9, "cycles for signed Str$(12345)", 13, 10

			invoke Sleep, SleepMs
			counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				void Str$("%u", 12345)
			counter_end
			print str$(eax), 9, "cycles for unsigned Str$(12345)", 13, 10
		endif

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke wsprintf, offset Dest, chr$("%u"), 12345
		counter_end
		print str$(eax), 9, "cycles for wsprintf 12345", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke umdtoa, 12345, offset Dest
		counter_end
		print str$(eax), 9, "cycles for umdtoa 12345", 13, 10

		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke dwtoa, 12345, offset Dest
		counter_end
		print str$(eax), 9, "cycles for dwtoa 12345", 13, 10, 10
	ENDM

	if useMB
		Print "Some fun with Str$():", CrLf$
		push 1000*7
		REPEAT 7
			fild dword ptr [esp]
			sub dword ptr [esp], 1000
		ENDM
		fldpi
		Print Str$("On FPU, ST(6):\t%6f\n", ST(6))	; prints but 6+7 are trashed afterwards
		Print Str$("On FPU, ST(1):\t%5f\n", ST(1))
		Print Str$("PI in ST(0):\t%Jf\n", ST(0))
		Print Str$("Qword:   \t%i\n", MyQword)
		Print Str$("Real4:    \t%Jf\n", MyR4)
		Print Str$("Real8:    \t%Jf\n", MyR8)
		movq xmm1, MyR8
		Print Str$("as xmm:    \t%Jf\n", f:xmm1)
		Print Str$("Real10:   \t%Jf\n", MyR10)
		mov ecx, -1
		Print Str$("ecx=-1, uns.:\t%u\n", ecx)
		Print Str$("ecx=-1, signed:\t%i\n", ecx)
		Print Str$("ecx=-1, cx:\t%i\n", cx)
		Print Str$("ecx=-1, cl:\t%i\n", cl)
		Print "Simple arithmetics (eax=100, xmm0=200, ecx=1000):", CrLf$
		mov eax, 200
		movd xmm0, eax
		mov eax, 100
		mov ecx, 1000
		Print Str$("-eax*xmm0/cx+100=%f\n", -eax*xmm0/cx+100)
		pop eax
	endif
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
